#include <ESP8266HTTPClient.h>  // install ESP8266:https://www.youtube.com/watch?v=0Lho9tLyh8E
#include <ESP8266WiFi.h>
#include <ArduinoJson.h>        // install with Library manager / über Bibliothek einbinden
#include "FastLED.h"            // install with Library manager / über Bibliothek einbinden

// W-Lan Setting
const char* ssid = "MySSID";
const char* password = "MYPassword";

// Osram Setting
String OsramUser    = "MyUsername";
String OsramPass    = "MyPassword";
String OsramSerial  = "OSR017*****";


String publictoken = "";
#define NUM_LEDS 1
#define DATA_PIN D5
#define SensorPin D6 //12
//#define LedPin D8 //15
const int digital = D8;
int menubutton = 0;

CRGB leds[NUM_LEDS];

int statuschange;
const unsigned long token_interval = 780000; //Send a request every 13 minutes
unsigned long token_timer;
const unsigned long Lamp_interval = 120000; // 120 Sec
unsigned long Lamp_timer;

void setup() {
  token_timer = token_interval;
  pinMode(digital, INPUT);
  Serial.begin(115200);
  Serial.println();
  Serial.print("connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  pinMode(SensorPin, INPUT);
  pinMode(BUILTIN_LED, OUTPUT);
  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS); // neopixel starten
  leds[0] = CRGB::Green ;
  FastLED.show();
}

void loop() {
  // take token
  if ((millis () - token_timer) >= token_interval) {
    taketoken();
    token_timer = millis ();
    Serial.print("publictoken: ");
    Serial.println(publictoken);
  }
  if (digitalRead(digital) == 1) {
    checkbutton();
  }
  if (menubutton == 0) {
    int sensorValue = digitalRead(SensorPin);
    if (sensorValue == HIGH) {
      digitalWrite(BUILTIN_LED, LOW);

      if (statuschange == 0) {
        switchOn("1","device"); // 1 = Lamp Number
        delay(1000);
        statuschange = 1;
        Serial.println("Sende Einschalten");
        leds[0] = CRGB::White;
        FastLED.show();
      } else {
        Lamp_timer = millis ();
      }
    } else {
      if ((millis () - Lamp_timer) >= Lamp_interval) {
        digitalWrite(BUILTIN_LED, HIGH);

        if (statuschange == 1) {
          switchOff("1","device"); // 1 = Lamp Number
          statuschange = 0;
          Serial.println("Sende Ausschalten");
          leds[0] = CRGB::Black;
          FastLED.show();
        }
      }
      Serial.println((millis () - Lamp_timer));
      delay(200);
    }
  }
}
